unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Buttons;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses mp_base, mp_types, mp_real;

// ő  [Nbȟݏ@ int64
function gcd_int64(x, y: int64): int64;
var
  t : int64;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[CvZ 1nt64 64rbg
// t[]͕q̒l
// q͕̒l
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  N = 26;
var
  i, m : integer;
  q, b1, b2, d: int64;
  c1, c2 : int64;
  t: array of int64;
  estr : string;
begin
  memo1.Clear;
  setlength(t, N + 1);                                   // zm zS0([)
// B0,B1
  m := 0;
  b1 := 1;
  memo1.lines.append('B' + inttostr(m) + ' =  ' + floatTostr(b1));
  m := 1;
//  b1 := -1;
  b2 := 2;
  memo1.lines.append('B' + inttostr(m) + ' =}' + floatTostr(b1) + ' / ' + floatTostr(b2));
// B2`
  q := 1;                                                // vZl
  t[1] := 1;                                             // qvZl
  for m := 2 to N do begin
    for i := 1 to m - 1 do t[i - 1] := i * t[i];         // qvZ
    t[m - 1] := 0;                                       // V
    for i := m downto 2 do t[i] := t[i] + t[i - 2];      // V
    if m mod 2 = 0 then begin                            // xk[CNoȂ
      q := q * 4;                                        // vZ
      b1 := m * t[0];                                    // q
      b2 := q * (q - 1);                                 // 
      c1 := b1 div m;                                    // b1 I[o[t[mFp
      c2 := b2 div (q - 1);                              // b2 I[o[t[mFp
      if (c1 = t[0]) and (c2 = q) then begin             // I[o[t[
        d := gcd_int64(b1, b2);                          // ő
        b1 := b1 div d;
        b2 := b2 div d;
        if m mod 4 = 0 then begin                        // 4̔{̃xk[CNo͕
          estr := ' = ';
          b1 := -b1;
        end
        else estr := ' =  ';
        memo1.lines.append('B' + inttostr(m) + estr + intTostr(b1) + ' / ' + intTostr(b2));
      end
      else break;
    end;
  end;
end;

// ő  [Nbȟݏ@ integer
function gcd_integer(x, y: integer): integer;
var
  t : integer;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// integer 32rbgvZ
procedure TForm1.BitBtn2Click(Sender: TObject);
const
  N = 16;
var
  i, m : integer;
  q, b1, b2, d: integer;
  c1, c2 : integer;
  t: array of integer;
  estr : string;
begin
  memo1.Clear;
  setlength(t, N + 1);                                   // zm zS0([)
// B0,B1
  m := 0;
  b1 := 1;
  memo1.lines.append('B' + inttostr(m) + ' =  ' + floatTostr(b1));
  m := 1;
//  b1 := -1;
  b2 := 2;
  memo1.lines.append('B' + inttostr(m) + ' =}' + floatTostr(b1) + ' / ' + floatTostr(b2));
// B2`
  q := 1;                                                // vZl
  t[1] := 1;                                             // qvZl
  for m := 2 to N do begin
    for i := 1 to m - 1 do t[i - 1] := i * t[i];         // qvZ
    t[m - 1] := 0;                                       // V
    for i := m downto 2 do t[i] := t[i] + t[i - 2];      // V
    if m mod 2 = 0 then begin                            // xk[CNoȂ
      q := q * 4;                                        // vZ
      b1 := m * t[0];                                    // q
      b2 := q * (q - 1);                                 // 
      c1 := b1 div m;                                    // b1 I[o[t[mFp
      c2 := b2 div (q - 1);                              // b2 I[o[t[mFp
      if (c1 = t[0]) and (c2 = q) then begin             // I[o[t[
        d := gcd_integer(b1, b2);                        // ő
        b1 := b1 div d;
        b2 := b2 div d;
        if m mod 4 = 0 then begin                        // 4̔{̃xk[CNo͕
          estr := ' = ';
          b1 := -b1;
        end
        else estr := ' =  ';
        memo1.lines.append('B' + inttostr(m) + estr + intTostr(b1) + ' / ' + intTostr(b2));
      end
      else break;
    end;
  end;
end;

// ő  [Nbȟݏ@ {
procedure gcd_mp_int(a, b: mp_int; var ans: mp_int);
var
  t : mp_int;
  x, y : mp_int;
begin
  mp_init3(t, x, y);
  mp_copy(a, x);
  mp_copy(b, y);
  repeat
    mp_mod(x, y, t);
    mp_copy(y, x);
    mp_copy(t, y);
  until s_mp_is_le0(y);
  mp_copy(x, ans);
  mp_clear3(t, x, y);
end;

// xk[C  {Z@
procedure TForm1.BitBtn3Click(Sender: TObject);
var
  i, m, N: integer;
  q, b1, b2, d, tmp, invE: mp_int;
  c1, c2, qm1: mp_int;
  b1f, b2f, bnf: mp_float;
  t: array of mp_int;
  estr : string;
begin
//  N := 2000;
  val(labelededit1.Text, N, i);
  if i <> 0 then begin
    Memo1.Clear;
    memo1.Text := '{BnN̒lɊԈႢ܂܂B';
    exit;
  end;
  N := abs(N);
  if N > 2000 then begin
    Memo1.Clear;
    memo1.Text := '{N̒l2000ɂĂB';
    exit;
  end;

  mp_init5(q, b1, b2, d, tmp);
  mp_init(invE);
  mp_init3(c1, c2, qm1);
  mpf_init3(b1f, b2f, bnf);

  setlength(t, N + 1);
  for i := 0 to N do mp_init(t[i]);

  memo1.Clear;
  mp_set1(b1);
  // B0 = 1
  if N = 0 then begin
    m := 0;
    memo1.lines.append('B' + inttostr(m) + ' =  ' + string(mp_adecimal(b1)));
  end;
  // B1 = -1 / 2
  if N = 1 then begin
    m := 1;
    mp_set_int(b2, 2);
//    mp_chs(b1, b1);
    memo1.lines.append('B' + inttostr(m) + ' =}' + string(mp_adecimal(b1))
                                          + ' / ' + string(mp_adecimal(b2)));
    mpf_set_mpi(b1f, b1);                      // _ϊ b1->b1f
    mpf_set_mpi(b2f, b2);                      // _ϊ b2->b2f
    mpf_div(b1f, b2f, bnf);                    // bnf = b1f/b2f
    memo1.lines.append('');
    memo1.lines.append('B' + inttostr(m) + ' =}' + string(mpf_adecimal_alt(bnf, 50)));
  end;
  // B2`
  if N >= 2 then begin
    if N mod 2 <> 0 then memo1.lines.append('B' + inttostr(N) + ' = 0')
    else begin
      mp_set1(q);                                        // vZl
      mp_set1(t[1]);                                     // qvZl
      for m := 2 to N do begin
        for i := 1 to m - 1 do mp_mul_int(t[i], i, t[i - 1]); // qvZ
        mp_set_int(t[m - 1], 0);                              // V
        for i := m downto 2 do mp_add(t[i], t[i - 2], t[i]);  // V
        if m mod 2 = 0 then begin                        // xk[CNoȂ
          mp_mul_int(q, 4, q);                           // vZ
          if m = N then begin                            // wxk[CɂȂ
            mp_mul_int(t[0], m, b1);                     // b1 = t[0] * m
            mp_sub_int(q, 1, qm1);                       // qm1 = q - 1
            mp_mul(q, qm1, b2);                          // b2 = q * (q - 1)
            mp_set_int(tmp, m);
            mp_div(b1, tmp, c1);                         // c1 = b1 / m
            mp_div(b2, qm1, c2);                         // c2 = b2 / (q - 1)
            if mp_is_eq(t[0], c1) and mp_is_eq(c2, q) then begin  // I[o[t[
              gcd_mp_int(b1, b2, d);                     // d = ő
              if m mod 4 = 0 then begin                  // Bn4̔{Ȃ
                estr := ' = ';
                mp_chs(b1, b1);                          // b1̕]
              end
              else estr := ' =  ';
              mp_div(b1, d, b1);                         // b1 = b1 / d
              mp_div(b2, d, b2);                         // b2 = b2 / d
              memo1.lines.append('B' + inttostr(m) + estr + string(mp_adecimal(b1))
                                                  + ' / ' + string(mp_adecimal(b2)));
              mpf_set_mpi(b1f, b1);                      // _ϊ b1->b1f
              mpf_set_mpi(b2f, b2);                      // _ϊ b2->b2f
              mpf_div(b1f, b2f, bnf);                    // bnf = b1f/b2f
              memo1.lines.append('');
              memo1.lines.append('B' + inttostr(m) + estr + string(mpf_adecimal_alt(bnf, 50)));
            end
            else break;
          end;
        end;
      end;
    end;
  end;

  for i := 0 to N do mp_clear(t[i]);
  mpf_clear3(b1f, b2f, bnf);
  mp_clear3(c1, c2, qm1);
  mp_clear(invE);
  mp_clear5(q, b1, b2, d, tmp);
end;

end.

